
% EMO MARKOV TOOL - EXAMPLE 3 - SIMULATION OF 2P2 IMEA ON DISCRETE LANDSCAPE 

clear;

a(1,2)= 1;
a(1,3)= 1;
a(2,4)= 1;
a(2,6)= 1;
a(2,1)= 1;
a(3,6)= 1;
a(3,5)= 1;
a(3,1)= 1;
a(4,7)= 1;
a(4,2)= 1;
a(5,3)= 1;
a(5,8)= 1;
a(6,7)= 1;
a(6,8)= 1;
a(6,2)= 1;
a(6,3)= 1;
a(7,4)= 1;
a(7,6)= 1;
a(7,9)= 1;
a(8,5)= 1;
a(8,6)= 1;
a(8,9)= 1;
a(9,7)= 1;
a(9,8)= 1;
a(9,10)= 1;
a(9,11)= 1;
a(10,9)= 1;
a(10,12)= 1;
a(11,9)= 1;
a(11,12)= 1;
a(12, 10)=1;
a(12, 11)=1;

f(1,:)=[4,4];
f(2,:)=[5,2];
f(3,:)=[2,5];
f(4,:)=[6,0];
f(5,:)=[0,6];
f(6,:)=[3,3];
f(7,:)=[4,1];
f(8,:)=[1,4];
f(9,:)=[2,2];
f(10,:)=[3,0];
f(11,:)=[0,3];
f(12,:)=[1,1];

L=12;

% compute neighborhoodsize for each node
for i=1:L
 c=0;
 for j=1:L
   if (a(i,j)==1) 
     c = c + 1;
   end
 end
   nbsize(i)=c;
end

TKernel = zeros(L^2, L^2);
% Compute: P(Given i1,i2 next state is j1,j2 which is the mutants)
for i1=1:L
    for i2=1:L
        for j1=1:L
            for j2=1:L
                % ptrans=pmut(i,j,k,ell)*psel(i,j,k,ell)
                % pmut=Probability that (i,j) mutate to (k, ell) 
                
                % when i is no neighbor of k or ell is no nb. of j we never
                % mutate to k,ell
                pmut_i1j1 = a(i1,j1) / sum(a(i1,:));
                pmut_i2j2 = a(i2,j2) / sum(a(i2,:));

                pmut = pmut_i1j1 * pmut_i2j2;

                indexes = [i1,i2,j1,j2];
                nd_flags = get_nd_solutions(f(indexes,:));
                % P(From i1, i2, j1, j2 we select (j1, j2))
                pselect = 0; % 'default' case
                if (sum(nd_flags) == 4) % all non-dominated
                    pselect = 1/6;
                elseif (sum(nd_flags) == 3) % three are non-dominated
                    if (nd_flags(3) == 1 && nd_flags(4) == 1)
                        pselect = 1/3;    
                    end
                elseif (sum(nd_flags) == 2) % two are non-dominated
                    if (nd_flags(3) == 1 && nd_flags(4) == 1)
                        pselect = 1;
                    end
                elseif (sum(nd_flags) == 1) % one is non-dominated
                    if (nd_flags(3) == 1)
                        indexes = [i1,i2,j2];
                        nd_flags = get_nd_solutions(f(indexes,:));
                        if (sum(nd_flags) == 3)
                            pselect = 1/3;
                        elseif (sum(nd_flags) == 2)
                            if (nd_flags(3) == 1)
                                pselect = 1/2;
                            end
                        elseif (sum(nd_flags) == 1)
                            if (nd_flags(3) == 1)
                                pselect = 1;
                            end
                        end
                    elseif (nd_flags(4) == 1)
                        indexes = [i1,i2,j1];
                        nd_flags = get_nd_solutions(f(indexes,:));
                        if (sum(nd_flags) == 3)
                            pselect = 1/3;
                        elseif (sum(nd_flags) == 2)
                            if (nd_flags(3) == 1)
                                pselect = 1/2;
                            end
                        elseif (sum(nd_flags) == 1)
                            if (nd_flags(3) == 1)
                                pselect = 1;
                            end
                        end                        
                    end
                end
                ptransition = pmut * pselect;
                TKernel(i1+(i2-1)*12,j1+(j2-1)*12) = TKernel(i1+(i2-1)*12,j1+(j2-1)*12)+ptransition;
            end
        end
    end
end

% Compute: P(Given i1, i2, next state is i1,i2 though mutated to j1,j2)
for i1=1:L
    for i2=1:L
        for j1=1:L
            for j2=1:L
                % mutate to j1,j2 given i1,i2
                pmut_i1j1 = a(i1,j1) / sum(a(i1,:));
                pmut_i2j2 = a(i2,j2) / sum(a(i2,:));

                pmut = pmut_i1j1 * pmut_i2j2;

                indexes = [i1,i2,j1,j2];
                nd_flags = get_nd_solutions(f(indexes,:));
                % P(From i1, i2, j1, j2 we select (i1, i2))
                pselect = 0; % 'default' case
                if (sum(nd_flags) == 4) % all non-dominated
                    pselect = 1/6;
                elseif (sum(nd_flags) == 3) % three are non-dominated
                    if (nd_flags(1) == 1 && nd_flags(2) == 1)
                        pselect = 1/3;
                    end
                elseif (sum(nd_flags) == 2) % two are non-dominated
                    if (nd_flags(1) == 1 && nd_flags(2) == 1)
                        pselect = 1;
                    end
                elseif (sum(nd_flags) == 1) % one is non-dominated
                    if (nd_flags(1) == 1)
                        indexes = [i2,j1,j2];
                        nd_flags = get_nd_solutions(f(indexes,:));
                        if (sum(nd_flags) == 3)
                            pselect = 1/3;
                        elseif (sum(nd_flags) == 2)
                            if (nd_flags(1) == 1)
                                pselect = 1/2;
                            end
                        elseif (sum(nd_flags) == 1)
                            if (nd_flags(1) == 1)
                                pselect = 1;
                            end
                        end
                    elseif (nd_flags(2) == 1)
                        indexes = [i1,j1,j2];
                        nd_flags = get_nd_solutions(f(indexes,:));
                        if (sum(nd_flags) == 3)
                            pselect = 1/3;
                        elseif (sum(nd_flags) == 2)
                            if (nd_flags(1) == 1)
                                pselect = 1/2;
                            end
                        elseif (sum(nd_flags) == 1)
                            if (nd_flags(1) == 1)
                                pselect = 1;
                            end
                        end                        
                    end
                end
                ptransition = pmut * pselect;
                TKernel(i1+(i2-1)*12,i1+(i2-1)*12) = TKernel(i1+(i2-1)*12,i1+(i2-1)*12) + ptransition;
            end
        end
    end
end

% Compute: P(Given i1, i2, next state is i1,j1 though mutated to j1,j2)
for i1=1:L
    for i2=1:L
        for j1=1:L
            for j2=1:L
                % mutate to j1,j2 given i1,i2
                pmut_i1j1 = a(i1,j1) / sum(a(i1,:));
                pmut_i2j2 = a(i2,j2) / sum(a(i2,:));
 
                pmut = pmut_i1j1 * pmut_i2j2;
                

                indexes = [i1,i2,j1,j2];
                nd_flags = get_nd_solutions(f(indexes,:));
                % P(From i1, i2, j1, j2 we select (i1, j1))
                pselect = 0; % 'default' case
                if (sum(nd_flags) == 4) % all non-dominated *
                    pselect = 1/6;
                elseif (sum(nd_flags) == 3) % three are non-dominated
                    if (nd_flags(1) == 1 && nd_flags(3) == 1)
                        pselect = 1/3;
                    end
                elseif (sum(nd_flags) == 2) % two are non-dominated
                    if (nd_flags(1) == 1 && nd_flags(3) == 1)
                        pselect = 1;
                    end
                elseif (sum(nd_flags) == 1) % one is non-dominated
                    if (nd_flags(1) == 1)
                        indexes = [i2,j1,j2];
                        nd_flags = get_nd_solutions(f(indexes,:));
                        if (sum(nd_flags) == 3)
                            pselect = 1/3;
                        elseif (sum(nd_flags) == 2)
                            if (nd_flags(2) == 1)
                                pselect = 1/2;
                            end
                        elseif (sum(nd_flags) == 1)
                            if (nd_flags(2) == 1)
                                pselect = 1;
                            end
                        end
                    elseif (nd_flags(3) == 1)
                        indexes = [i1,i2,j2];
                        nd_flags = get_nd_solutions(f(indexes,:));
                        if (sum(nd_flags) == 3)
                            pselect = 1/3;
                        elseif (sum(nd_flags) == 2)
                            if (nd_flags(1) == 1)
                                pselect = 1/2;
                            end
                        elseif (sum(nd_flags) == 1)
                            if (nd_flags(1) == 1)
                                pselect = 1;
                            end
                        end                        
                    end
                end
                ptransition = pmut * pselect;
                TKernel(i1+(i2-1)*12,i1+(j1-1)*12) = TKernel(i1+(i2-1)*12,i1+(j1-1)*12) + ptransition/2;
                TKernel(i1+(i2-1)*12,j1+(i1-1)*12) = TKernel(i1+(i2-1)*12,j1+(i1-1)*12) + ptransition/2;
            end
        end
    end
end

% Compute: P(Given i1, i2, next state is i1, j2 though mutated to j1, j2)
for i1=1:L
    for i2=1:L
        for j1=1:L
            for j2=1:L
                % mutate to j1,j2 given i1,i2
                pmut_i1j1 = a(i1,j1) / sum(a(i1,:));
                pmut_i2j2 = a(i2,j2) / sum(a(i2,:));
     
                pmut = pmut_i1j1 * pmut_i2j2;
              

                indexes = [i1,i2,j1,j2];
                nd_flags = get_nd_solutions(f(indexes,:));
                % P(From i1, i2, j1, j2 we select (i1, j1))
                pselect = 0; % 'default' case
                if (sum(nd_flags) == 4) % all non-dominated *
                    pselect = 1/6;
                elseif (sum(nd_flags) == 3) % three are non-dominated
                    if (nd_flags(1) == 1 && nd_flags(4) == 1)
                        pselect = 1/3;
                    end
                elseif (sum(nd_flags) == 2) % two are non-dominated
                    if (nd_flags(1) == 1 && nd_flags(4) == 1)
                        pselect = 1;
                    end
                elseif (sum(nd_flags) == 1) % one is non-dominated
                    if (nd_flags(1) == 1)
                        indexes = [i2,j1,j2];
                        nd_flags = get_nd_solutions(f(indexes,:));
                        if (sum(nd_flags) == 3)
                            pselect = 1/3;
                        elseif (sum(nd_flags) == 2)
                            if (nd_flags(3) == 1)
                                pselect = 1/2;
                            end
                        elseif (sum(nd_flags) == 1)
                            if (nd_flags(3) == 1)
                                pselect = 1;
                            end
                        end
                    elseif (nd_flags(4) == 1)
                        indexes = [i1,i2,j1];
                        nd_flags = get_nd_solutions(f(indexes,:));
                        if (sum(nd_flags) == 3)
                            pselect = 1/3;
                        elseif (sum(nd_flags) == 2)
                            if (nd_flags(1) == 1)
                                pselect = 1/2;
                            end
                        elseif (sum(nd_flags) == 1)
                            if (nd_flags(1) == 1)
                                pselect = 1;
                            end
                        end                        
                    end
                end
                ptransition = pmut * pselect;
                TKernel(i1+(i2-1)*12,i1+(j2-1)*12) = TKernel(i1+(i2-1)*12,i1+(j2-1)*12) + ptransition/2;
                TKernel(i1+(i2-1)*12,j2+(i1-1)*12) = TKernel(i1+(i2-1)*12,j2+(i1-1)*12) + ptransition/2;
            end
        end
    end
end

% Compute: P(Given i1, i2, next state is i2, j1 though mutated to j1, j2)
for i1=1:L
    for i2=1:L
        for j1=1:L
            for j2=1:L
                % mutate to j1,j2 given i1,i2
                pmut_i1j1 = a(i1,j1) / sum(a(i1,:));
                pmut_i2j2 = a(i2,j2) / sum(a(i2,:));
     
                pmut = pmut_i1j1 * pmut_i2j2;
             

                indexes = [i1,i2,j1,j2];
                nd_flags = get_nd_solutions(f(indexes,:));
                % P(From i1, i2, j1, j2 we select (i1, j1))
                pselect = 0; % 'default' case
                if (sum(nd_flags) == 4) % all non-dominated *
                    pselect = 1/6;
                elseif (sum(nd_flags) == 3) % three are non-dominated
                    if (nd_flags(2) == 1 && nd_flags(3) == 1)
                        pselect = 1/3;
                    end
                elseif (sum(nd_flags) == 2) % two are non-dominated
                    if (nd_flags(2) == 1 && nd_flags(3) == 1)
                        pselect = 1;
                    end
                elseif (sum(nd_flags) == 1) % one is non-dominated
                    if (nd_flags(2) == 1)
                        indexes = [i1,j1,j2];
                        nd_flags = get_nd_solutions(f(indexes,:));
                        if (sum(nd_flags) == 3)
                            pselect = 1/3;
                        elseif (sum(nd_flags) == 2)
                            if (nd_flags(2) == 1)
                                pselect = 1/2;
                            end
                        elseif (sum(nd_flags) == 1)
                            if (nd_flags(2) == 1)
                                pselect = 1;
                            end
                        end
                    elseif (nd_flags(3) == 1)
                        indexes = [i1,i2,j2];
                        nd_flags = get_nd_solutions(f(indexes,:));
                        if (sum(nd_flags) == 3)
                            pselect = 1/3;
                        elseif (sum(nd_flags) == 2)
                            if (nd_flags(2) == 1)
                                pselect = 1/2;
                            end
                        elseif (sum(nd_flags) == 1)
                            if (nd_flags(2) == 1)
                                pselect = 1;
                            end
                        end                        
                    end
                end
                ptransition = pmut * pselect;
                TKernel(i1+(i2-1)*12,i2+(j1-1)*12) = TKernel(i1+(i2-1)*12,i2+(j1-1)*12) + ptransition/2;
                TKernel(i1+(i2-1)*12,j1+(i2-1)*12) = TKernel(i1+(i2-1)*12,j1+(i2-1)*12) + ptransition/2;
            end
        end
    end
end

% Compute: P(Given i1, i2, next state is i2, j2 though mutated to j1, j2)
for i1=1:L
    for i2=1:L
        for j1=1:L
            for j2=1:L
                % mutate to j1,j2 given i1,i2
                pmut_i1j1 = a(i1,j1) / sum(a(i1,:));
                pmut_i2j2 = a(i2,j2) / sum(a(i2,:));
              
                pmut = pmut_i1j1*pmut_i2j2;   
                

                indexes = [i1,i2,j1,j2];
                nd_flags = get_nd_solutions(f(indexes,:));
                % P(From i1, i2, j1, j2 we select (i1, j1))
                pselect = 0; % 'default' case
                if (sum(nd_flags) == 4) % all non-dominated *
                    pselect = 1/6;
                elseif (sum(nd_flags) == 3) % three are non-dominated
                    if (nd_flags(2) == 1 && nd_flags(4) == 1)
                        pselect = 1/3;
                    end
                elseif (sum(nd_flags) == 2) % two are non-dominated
                    if (nd_flags(2) == 1 && nd_flags(4) == 1)
                        pselect = 1;
                    end
                elseif (sum(nd_flags) == 1) % one is non-dominated
                    if (nd_flags(2) == 1)
                        indexes = [i1,j1,j2];
                        nd_flags = get_nd_solutions(f(indexes,:));
                        if (sum(nd_flags) == 3)
                            pselect = 1/3;
                        elseif (sum(nd_flags) == 2)
                            if (nd_flags(3) == 1)
                                pselect = 1/2;
                            end
                        elseif (sum(nd_flags) == 1)
                            if (nd_flags(3) == 1)
                                pselect = 1;
                            end
                        end
                    elseif (nd_flags(4) == 1)
                        indexes = [i1,i2,j1];
                        nd_flags = get_nd_solutions(f(indexes,:));
                        if (sum(nd_flags) == 3)
                            pselect = 1/3;
                        elseif (sum(nd_flags) == 2)
                            if (nd_flags(2) == 1)
                                pselect = 1/2;
                            end
                        elseif (sum(nd_flags) == 1)
                            if (nd_flags(2) == 1)
                                pselect = 1;
                            end
                        end                        
                    end
                end
                ptransition = pmut * pselect;
                TKernel(i1+(i2-1)*12,i2+(j2-1)*12) = TKernel(i1+(i2-1)*12,i2+(j2-1)*12) + ptransition/2;
                TKernel(i1+(i2-1)*12,j2+(i2-1)*12) = TKernel(i1+(i2-1)*12,j2+(i2-1)*12) + ptransition/2;
            end
        end
    end
end
for i1=1:L
    for i2=1:L
        for j1=1:L
            for j2=1:L
               if (TKernel(i1+(i2-1)*12,j1+(j2-1)*12) ~= TKernel(i2+(i1-1)*12,j2+(j1-1)*12))
                   result=[i1,i2,j1,j2]
               end
           end
       end
   end
end
size(TKernel)
TKernel
sum(TKernel)
sum(TKernel')
L = 144;
% initial state
for i=1:L
  p(i)=1/L;%1/L;
end
%p(1) = 1;

pnew=p;
for index = 1 : 7000
  pnew= pnew * TKernel;
end

for i=1:12
    for j=1:12
        P(i,j)=pnew(i+(j-1)*12);
    end
end



% THE RESULT OF THE SIMULATION IS IN P, VERIFY pnew= pnew * TKernel!





%pinv=pnew*inv(eye(12)-TKernel);
% 
% d = 3;
% 
% 
% plot2d(pnew);
